Title: test_asyncio.test_read_pty_output() fails on "AMD64 Snow Leop 3.x" buildbot
Type: Stage: resolved
Components: Tests Versions: Python 3.4
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: gvanrossum, python-dev, vstinner
Priority: normal Keywords: buildbot

Created on 2014-01-23 14:33 by vstinner, last changed 2014-01-23 16:29 by python-dev. This issue is now closed.

Messages (3)
msg208941 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2014-01-23 14:33
kqueue doesn't support character devices like PTY before Mac OS 10.9. This issue is discussion on Tulip mailing list, no decision was taken yet how to fix this issue.

ERROR: test_read_pty_output (test.test_asyncio.test_events.KqueueEventLoopTests)
Traceback (most recent call last):
  File "/Users/buildbot/buildarea/3.x.murray-snowleopard/build/Lib/asyncio/", line 135, in add_reader
    key = self._selector.get_key(fd)
  File "/Users/buildbot/buildarea/3.x.murray-snowleopard/build/Lib/", line 181, in get_key
    raise KeyError("{!r} is not registered".format(fileobj)) from None
KeyError: '7 is not registered'

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/Users/buildbot/buildarea/3.x.murray-snowleopard/build/Lib/test/test_asyncio/", line 980, in test_read_pty_output
  File "/Users/buildbot/buildarea/3.x.murray-snowleopard/build/Lib/asyncio/", line 177, in run_until_complete
    return future.result()
  File "/Users/buildbot/buildarea/3.x.murray-snowleopard/build/Lib/asyncio/", line 236, in result
    raise self._exception
  File "/Users/buildbot/buildarea/3.x.murray-snowleopard/build/Lib/asyncio/", line 281, in _step
    result = next(coro)
  File "/Users/buildbot/buildarea/3.x.murray-snowleopard/build/Lib/test/test_asyncio/", line 974, in connect
  File "/Users/buildbot/buildarea/3.x.murray-snowleopard/build/Lib/asyncio/", line 537, in connect_read_pipe
    transport = self._make_read_pipe_transport(pipe, protocol, waiter)
  File "/Users/buildbot/buildarea/3.x.murray-snowleopard/build/Lib/asyncio/", line 149, in _make_read_pipe_transport
    return _UnixReadPipeTransport(self, pipe, protocol, waiter, extra)
  File "/Users/buildbot/buildarea/3.x.murray-snowleopard/build/Lib/asyncio/", line 200, in __init__
    self._loop.add_reader(self._fileno, self._read_ready)
  File "/Users/buildbot/buildarea/3.x.murray-snowleopard/build/Lib/asyncio/", line 138, in add_reader
    (handle, None))
  File "/Users/buildbot/buildarea/3.x.murray-snowleopard/build/Lib/", line 462, in register
    self._kqueue.control([kev], 0, 0)
OSError: [Errno 22] Invalid argument
msg208965 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2014-01-23 16:24
The issue was discussed here:

The decision is to skip the test on Mac OS X < 10.9.
msg208966 - (view) Author: Roundup Robot (python-dev) Date: 2014-01-23 16:29
New changeset 424564cffad0 by Victor Stinner in branch 'default':
Close #20365: Skip test_asyncio.test_events.test_read_pty_output() on Mac OS X
Date User Action Args
2014-01-23 16:29:21python-devsetstatus: open -> closed

nosy: + python-dev
messages: + msg208966

resolution: fixed
stage: resolved
2014-01-23 16:24:39vstinnersetmessages: + msg208965
2014-01-23 14:33:19vstinnercreate